package mobilemath;

import javax.microedition.lcdui.*;
import tool.*;
import parser.*;
import java.util.Vector;
import java.lang.Math;

public class FormCal extends Canvas implements CommandListener {
 FormMenu parent;
 Image tmpimg;
 Graphics g;
 Function f = new Function();
 Font font = Font.getDefaultFont();
 boolean isresult = false;
 int i, j, tmpi;
 //Parameter
 int butX = 2, butY = 32;
 int butSizeX = 26, butSizeY = 26;
 int butDis = 2;
 int panelX = 2, panelY = 2, panelWidth = Locale.ScrWidth-4, panelHeight = 26;
 int colorText = 0, colorPanel = 256*256*256-1;
 //Color
 int colorNormal = 80*256+255,
     colorSelected = 255*256*256+128*256;
 int m = 5, n = 5, status;
 //Expression
 String []sLabel = new String[] {
   "AC","(",")",".,","deg",
   "+","-","*","/","^",
   "sin","cos","tan","pi","=",
   "exp","ln","sqrt","abs","Ans",
   "pt2","hp2","dif","int","x"
 };
 String []sReplace  = new String[] {
   "AC","(",")",".","deg",
   "+","-","*","/","^",
   "sin(","cos(","tan(","pi","=",
   "exp(","ln(","sqrt(","abs(","Ans",
   "pt2(","hp2(","dif(","int(","x"
 };

 String sInput = "";
 String oldres = "0", s;

 public FormCal() {
  try {
   jbInit();
   tmpimg = Image.createImage(Locale.ScrWidth, Locale.ScrHeight);
   g = tmpimg.getGraphics();
   g.drawImage(tmpimg, 0, 0, 0);
  }
  catch(Exception e) {
   e.printStackTrace();
  }
 }

 private void jbInit() throws Exception {
  setCommandListener(this);
  setFullScreenMode (true);
  addCommand(new Command(Locale.CALC_CMD, Command.OK, 1));
  addCommand(new Command(Locale.BACK_CMD, Command.EXIT, 1));
 }

 public void commandAction(Command command, Displayable displayable) {
  if (command.getCommandType() == command.OK) {
   if (status == 0) solve();
   else {
    try	{
     sInput = Utils.strReplace(sInput.toUpperCase(), "PI", ""+3.142);
     parent.frmGraph.exp = sInput;
     parent.frmGraph.reCal();
    }
    catch (Exception ex) { }
    Main.instance.setDisplay(parent.frmGraph);
   }
  }
  else if (command.getCommandType() == Command.EXIT) {
   if (status == 0) Main.instance.setDisplay(parent);
   else	Main.instance.setDisplay(parent.frmGraph);
  }
 }

 public void setStatus(int status, String sInput) {
  this.status = status;
  if (status == 0) {
   sLabel[20] = "pt2"; sLabel[21] = "hp2"; sLabel[22] = "dif";
   sLabel[23] = "int"; sLabel[24] = "x"; sLabel[19] = "Ans";
   for (int i=20; i<24; i++)
    sReplace[i] = sLabel[i] + '(';
   sReplace[19] = "Ans"; sReplace[24] = "x";
  }
  else {
   sLabel[20] = "_"; sLabel[21] = ";"; sLabel[22] = "t";
   sLabel[23] = "r"; sLabel[24] = "y"; sLabel[19] = "x";
   for (int i=19; i<25; i++)
    sReplace[i] = sLabel[i];
  }
  for (i=0; i<m; i++)
  for(j=0; j<n; j++)
   drawCell(i, j, false);
  i = 0; j = 0; this.sInput = sInput;
  drawCell(i, j, true);
  drawPanel(); 
  repaint();
 }

 void drawCell (int i, int j, boolean selected) {
  //Draw cell
  if (selected) g.setColor(colorSelected);
  else g.setColor(colorNormal);
  g.fillRect(butX + j * butSizeX, butY + i * butSizeY, butSizeX - butDis, butSizeY - butDis);
  //Draw Label
  g.setFont(font);
  g.setColor(colorPanel);
  s = sLabel[i*n+j];
  tmpi = (butSizeX - butDis - font.stringWidth(s))/2;
  g.drawString(s, butX + j * butSizeX + tmpi, butY + i * butSizeY, g.LEFT|g.TOP);
 }

 void drawPanel () {
  //Draw panel
  g.setColor(colorPanel);
  g.fillRect(panelX, panelY, panelWidth, panelHeight);
  //Draw Input
  g.setColor(colorText);
  s = sInput + "_";
  while (font.stringWidth(s) > panelWidth - 6)
   s = s.substring(1);
  g.drawString(s, panelX+5, panelY+2, 0);
 }

 public void keyPressed(int keyCode) {
  //Autoadd Ans
  s = getKeyName(keyCode);
  if (isresult)	{
   if ("UPDOWNLEFTRIGHT".indexOf(s) < 0) {
    if ("01234567890CLEARPOUND".indexOf(s) >= 0) sInput = "";
    else if ("+-*/^".indexOf(sLabel[i*5+j]) >= 0) sInput = "Ans";
    else sInput = "";
    isresult = false;
   }
  }
  //Process key
  if (s.compareTo("CLEAR") == 0) {
   if (sInput.length() > 0)
    sInput = sInput.substring(0, sInput.length() - 1);
  }
  else if (s.compareTo("POUND") == 0) {
   if (sInput.length()>0 && sInput.endsWith(".")) {
    sInput = sInput.substring(0,sInput.length()-1)+","; 
   }
   else sInput += ".";
  }
  else if ("0123456789".indexOf(s) >= 0)
   sInput += getKeyName(keyCode);
  else {
   drawCell(i, j, false);
   keyCode = getGameAction(keyCode);
   switch (keyCode) {
    case UP:
     if (i > 0) i--;
     else i = m-1;
    break;
    case DOWN:
     if (i < m-1) i++;
     else i = 0;
    break;
    case LEFT:
     if (j > 0) j--;
     else j = n-1;
    break;
    case RIGHT:
     if (j < n-1) j++;
     else j = 0;
    break;
    case FIRE:
     s = sLabel[i*n+j];
     if (s.compareTo("AC") == 0) sInput = "";
     else if (s.compareTo("=") == 0) {
      if (status == 0) {
       drawCell(i, j, true);
       solve ();
       return;
      }
      sInput += sReplace[i*n+j];
     }
     else if (s.compareTo("deg") == 0) {
      sLabel[4] = "rad";
      drawCell(0, 4, false);
     }
     else if (s.compareTo("rad") == 0) {
      sLabel[4] = "deg";
      drawCell(0,4,false);
     }
     else {
      if (i==0 && j==3 && sInput.length()>0 && sInput.endsWith(".")) {
       sInput = sInput.substring(0,sInput.length()-1)+",";
      }
      else sInput += sReplace[i*n+j];
     }
    break;
   }
   drawCell(i, j, true);
  }
  drawPanel(); repaint();
 }

 protected void paint(Graphics g) {
  g.drawImage(tmpimg, 0, 0, 0);
 }

 void solve() {
  isresult = true;
  try {
   //Replace string
   s = sInput.toUpperCase();
   s = Utils.strReplace(s, "PI", ""+3.142);
   s = Utils.strReplace(s, "ANS", oldres);
   //Solve if detect this is a equation
   if (s.length() > 2)
    if (s.substring(0, 3).compareTo("PT2") == 0) {
     s = s.substring(4);
     int k = s.indexOf(")");
     s = s.substring(0, k);
     Utils.strSplitOf(s, ',');
     double a = Float.parseFloat(Utils.arr[0]);
     double b = Float.parseFloat(Utils.arr[1]);
     double c = Float.parseFloat(Utils.arr[2]);
     double delta = b * b - 4 * a * c;
     if (delta == 0)
      sInput = "X=" + String.valueOf(b / 2 / 1);
     else if (delta > 0) {
      delta = Math.sqrt(delta);
      sInput = "X=" + String.valueOf(Utils.trunc( ( -b + delta) / 2 / a)) + ";" +
               String.valueOf(Utils.trunc( ( -b - delta) / 2 / a));
     }
     else
      sInput = Locale.NoSolution;
     drawPanel();
     repaint();
     return;
    }
   if (s.length() > 2)
    if (s.substring(0, 3).compareTo("HP2") == 0) {
     s = s.substring(4);
     int k = s.indexOf(")");
     s = s.substring(0, k);
     Utils.strSplitOf(s, ',');
     double a1 = Float.parseFloat(Utils.arr[0]);
     double b1 = Float.parseFloat(Utils.arr[1]);
     double c1 = Float.parseFloat(Utils.arr[2]);
     double a2 = Float.parseFloat(Utils.arr[3]);
     double b2 = Float.parseFloat(Utils.arr[4]);
     double c2 = Float.parseFloat(Utils.arr[5]);
     double d = a1 * b2 - a2 * b1;
     double dx = c1 * b2 - c2 * b1;
     double dy = a1 * c2 - a2 * c1;
     if (d == 0) {
      if ( (dx != 0) || (dy != 0))
       sInput = Locale.NoSolution;
      else
       sInput = Locale.NoSolution;
     }
     else
      sInput = "X=" + Utils.trunc(dx / d) + ";Y=" + Utils.trunc(dy / d);
     drawPanel();
     repaint();
     return;
    }
   //Dif
   if (s.length() > 2)
    if (s.substring(0, 3).compareTo("DIF") == 0) {
     s = s.substring(4);
     int k = s.indexOf(")");
     s = s.substring(0, k);
     Utils.strSplitOf(s, ',');
     s = Utils.arr[0];
     double v1, v2, r, x = Float.parseFloat(Utils.arr[1]);
     //Create function
     Utils.prepareVal('X',s);
     v1 = Utils.Cal(x+0.001);
     v2 = Utils.Cal(x-0.001);
     r = Utils.round((v1-v2)*50000)/100;
     sInput = String.valueOf(r);
     oldres = sInput;
     drawPanel(); 
     repaint();
     return;
    }
   if (s.length() > 2)
    if (s.substring(0, 3).compareTo("INT") == 0) {
     s = s.substring(4);
     int k = s.indexOf(")");
     s = s.substring(0, k);
     Utils.strSplitOf(s, ',');
     s = Utils.arr[0];
     double x1 = Float.parseFloat(Utils.arr[1]);
     double x2 = Float.parseFloat(Utils.arr[2]);
     //Create function
     Utils.prepareVal('X', s);
     double dis = (x2-x1)/100, sum = 0;
     for (int i=0; i<100; i++)
      sum += Utils.Cal(x1+dis*i+dis/2);
     sInput = String.valueOf(Utils.round(sum*dis*1000)/1000);
     drawPanel();
     repaint();
     return;
    }
   //Evaluate
   if (sLabel[4].compareTo("deg") == 0)
    PostfixOperation.rad = false;
   f.initialize(s);
   sInput = String.valueOf(Utils.trunc(f.calculate(null)));
   oldres = sInput;
  }
  catch (Exception ex) {
   sInput = Locale.NoSolution;
  }
  finally {
   PostfixOperation.rad = true;
   drawPanel(); 
   repaint();
  }
 }

}
