package mobilemath;

import javax.microedition.lcdui.*;
import tool.*;

public class FormGraph extends Canvas implements CommandListener {
 FormMenu parent;
 Graph graph;
 Image tempimg;
 Graphics tempg;
 Command c1,c2,c3,c6;
 int [] color = new int[] {
  255 * 256,
  256*256*256-1,
  255*256*256+255*256,
  255*256+255,
  255,
  255*256*256+255,
  255*256*256,
 };

 String exp = Locale.DefaultGraphStr;
 String []f;

 public FormGraph() {
  try {
   jbInit();
   reCal();
  }
  catch (Exception e) {
   e.printStackTrace();
  }
 }

 private void jbInit() throws Exception	{
  setCommandListener(this);
  setFullScreenMode (true);
  addCommand(new Command(Locale.INPUT_CMD, Command.OK, 0));
  addCommand(new Command(Locale.BACK_CMD, Command.EXIT, 1));
  c1=new Command(Locale.PLUS_CMD, Command.ITEM, 2);
  addCommand(c1);
  c2=new Command(Locale.MINUS_CMD, Command.ITEM, 2);
  addCommand(c2);
  c3=new Command(Locale.AXIS_CMD, Command.ITEM, 2);
  addCommand(c3);
  c6=new Command(Locale.DOTS_CMD, Command.ITEM, 2);
  addCommand(c6);
 }

 public void commandAction(Command command, Displayable displayable) {
  if (command.getCommandType() == Command.OK) {
   if (parent.frmCal == null) {
    parent.frmCal = new FormCal();
    parent.frmCal.parent = parent;
   }
   parent.frmCal.setStatus(1, exp);
   Main.instance.setDisplay(parent.frmCal);
  }
  else if (command.getCommandType() == Command.EXIT)
   Main.instance.setDisplay(parent);
  else if (command == c1) func_1 ();
  else if (command == c2) func_2 ();
  else if (command == c3) func_3 ();
  else if (command == c6) func_6 ();
 }

 public void reCal() {
  Utils.strSplitOf (exp.toUpperCase(),';');
  f = Utils.arr;
 }

 protected void paint(Graphics g) {
  if (graph == null) {
   tempimg = Image.createImage(Locale.ScrWidth, Locale.ScrHeight);
   tempg = tempimg.getGraphics();
   graph = new Graph (tempg, tempimg.getWidth(), tempimg.getHeight());
  }

  graph.DrawAxis();
  try {
   for (int i = 0; i < f.length; i++) {
    tempg.setColor(color[i % color.length]);
    if (f[i].substring(0, 2).compareTo("Y=") == 0)
     graph.DrawYX(f[i], -10, 10);
    else if (f[i].substring(0, 2).compareTo("R=") == 0)
     graph.DrawRT(f[i], -180, 180);
    else if (f[i].substring(0, 2).compareTo("X=") == 0)
     graph.DrawXY(f[i], -10, 10);
    else if (f[i].substring(0, 3).compareTo("XT=") == 0)
     graph.DrawYXT(f[i], -10, 10);
   }
  }
  catch(Exception ex) {}
  g.drawImage(tempimg, 0, 0, 0);
 }

 public void func_1 () {
  graph.op++;
  repaint();
 }

 public void func_2 () {
  graph.op--;
  repaint();
 }

 public void func_3 () {
  graph.axisVisible = !graph.axisVisible;
  repaint();
 }

 public void func_6 () {
  graph.grid = !graph.grid;
  repaint();
 }

 public void keyPressed(int keyCode) {
  switch(keyCode) {
   case KEY_NUM1:
    func_1 ();
   break;
   case KEY_NUM2:
    func_2 ();
   break;
   case KEY_NUM3:
    func_3 ();
   break;
   case KEY_NUM6:
    func_6 ();
   break;
   default:
    int gameAction = getGameAction(keyCode);
    switch (gameAction) {
     case LEFT:
      graph.ox -= 15;
     break;
     case RIGHT:
      graph.ox += 15;
     break;
     case UP:
      graph.oy -= 15;
     break;
     case DOWN:
      graph.oy += 15;
     break;
    }
    repaint();
   break;
  }
 }

}
