package parser;

import java.util.Vector;
import tool.Locale;

public class DoubleValueOperation implements Operation {

 protected int typ;

 public DoubleValueOperation(int typ) {
  this.typ = typ;
 }

 public Node[] devideAndCreate(String string) {
  Node[] nodes = new Node[2];
  nodes[0] = NodeFactory.newInstance(getErsterKlammernTeil(string, '('));
  nodes[1] = NodeFactory.newInstance(getErsterKlammernTeil(string, '['));
  return nodes;
 }

 public double link(Node[] nodes, Vector variables) {
  switch ( typ ) {
   case LOG:
    return tool.Utils.ln(nodes[0].getValue(variables)) / tool.Utils.ln(nodes[1].getValue(variables));
   case ROOT:
    if ( nodes[1].getValue(variables) == 2 ) {
     return Math.sqrt(nodes[0].getValue(variables));
    }
    else {
     return tool.Utils.pow(nodes[0].getValue(variables),1/nodes[1].getValue(variables));
    }
  }
  throw new RuntimeException(Locale.BadType+typ);
 }


 /**
  * input="sin(x+5+ln(x)) typ='(' => return is: x+5+ln(x) <br>
  * input="root[ln(x)](sin(x)) typ='[' => return is: ln(x) <br>
 */
 private String getErsterKlammernTeil(String input, char typ) {
  int startKa=0,endeKa=0,startKea=0,endeKea=0;
  int ka = 0, kea=0;
  for ( int i = 0 ; i < input.length() ; i++) {
   if ( input.charAt(i) == '(' && kea==0 ) {
    if ( ka == 0 ) {
     startKa = i+1;
    }
    ka++;
   }
   else if ( input.charAt(i) == ')'  && kea==0 ) {
    ka--;
    if ( ka == 0 ) {
     endeKa = i;
    }
   }
   else if ( input.charAt(i) == '['  && ka==0 ) {
    if ( kea == 0 ) {
     startKea = i+1;
    }
    kea++;
   }
   else if ( input.charAt(i) == ']'  && ka==0 ) {
    kea--;
    if ( kea == 0 ) {
     endeKea = i;
    }
   }
  }
  if ( typ == '(' ) {
   return input.substring(startKa,endeKa);
  }
  else if ( typ == '[' ) {
   return input.substring(startKea,endeKea);
  }
  else {
   throw new RuntimeException(Locale.BadLeksem+typ);
  }
 }

}

