package parser;

import java.util.Vector;
import tool.Locale;

/**
 * <p>
 *    Variable v = new Variable('x');<br>
 *    v.setValue(9);<br>
 *    Vector vec = new Vector();<br>
 *    vec.addElement(v);<br>
 *<br>
 *    Function f = new Function("root[2](x)");<br>
 *    double res = f.calculate(vec);<br>
*/
public class Function {
 private Node root;

 public Function() { }

 public Function(String stringToParse) {
  initialize(stringToParse);
 }

 public double calculate(Vector variables) {
  return root.getValue(variables);
 }

 public void initialize(String stringToParse) {
  root = NodeFactory.newInstance(stringToParse);
 }

 static public void main(String args[]) {
  Variable v = new Variable('x');
  v.setValue(4);
  Vector vec = new Vector();
  vec.addElement(v);

  Function f = new Function(Locale.DefaultFunction);
  double res = f.calculate(vec);
  //System.out.println(res);
 }

}
