package parser;

import tool.Locale;

public class OperationFactory {

 private OperationFactory() { }

 public static Operation getNextOperation(String string) {
  int ka=0,kea=0;
  int plus=-1,minus=-1,mal=-1,geteilt=-1,hoch=-1;

  for (int i = 0 ; i< string.length() ; i++) {
   if (string.charAt(i)=='(') ka++;
   if (string.charAt(i)==')') ka--;
   if (string.charAt(i)=='[') kea++;
   if (string.charAt(i)==']') kea--;
   if (plus==-1     && string.charAt(i)=='+' && ka==0 && kea==0)  plus=i;
   if (minus==-1    && string.charAt(i)=='-' && ka==0 && kea==0)  minus=i;
   if (mal==-1      && string.charAt(i)=='*' && ka==0 && kea==0)  mal=i;
   if (geteilt==-1  && string.charAt(i)=='/' && ka==0 && kea==0)  geteilt=i;
   if (hoch==-1     && string.charAt(i)=='^' && ka==0 && kea==0)  hoch=i;
  }

  if (plus>-1)    return new BasicOperation(plus, Operation.PLUS);

  if (minus>-1 && !(plus==minus-1||mal==minus-1||geteilt==minus-1||hoch==minus-1) )   return new BasicOperation(minus, Operation.MINUS);
  if (mal>-1)     return new BasicOperation(mal, Operation.MULTIPLICATION);
  if (geteilt>-1) return new BasicOperation(geteilt, Operation.DIVISION);
  if (hoch>-1)    return new BasicOperation(hoch, Operation.POWER);

  if ( string.startsWith("LN")   ) return new PostfixOperation(Operation.LN);
  if ( string.startsWith("EXP")  ) return new PostfixOperation(Operation.EXP);
  if ( string.startsWith("SIN")  ) return new PostfixOperation(Operation.SIN);
  if ( string.startsWith("COS")  ) return new PostfixOperation(Operation.COS);
  if ( string.startsWith("TAN")  ) return new PostfixOperation(Operation.TAN);
/*
  if ( string.startsWith("ASIN") ) return new PostfixOperation(Operation.ASIN);
  if ( string.startsWith("ACOS") ) return new PostfixOperation(Operation.ACOS);
  if ( string.startsWith("ATAN") ) return new PostfixOperation(Operation.ATAN);
*/
  if ( string.startsWith("LOG")  ) return new DoubleValueOperation(Operation.LOG);
  if ( string.startsWith("ROOT") ) return new DoubleValueOperation(Operation.ROOT);
  //Add
  if ( string.startsWith("ABS") ) return new PostfixOperation(Operation.ABS);
  if ( string.startsWith("SQRT") ) return new PostfixOperation(Operation.SQRT);
  throw new RuntimeException(Locale.CantParse+string);
 }

}
